<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource\Manager;
use \Exception as Exception;

class IntegracaoParaGeral extends CrudWithParameterBag {
    
    const dataSourceOperador      = 'operadorExterno';
    const dataSourceTipoRece      = 'tiporeceExterno';
    const dataSourceImposto       = 'impostoExterno';
    const dataSourceAliquota      = 'aliquotaExterno';
    protected $parameterBagColumns = array('NRORG');
    protected $util;
    protected $crudService;
    
              
    public function __construct (ParameterBag $parameterBag, Manager $dataSourceManager, $util, $crudService) {
        $this->parameterBag = $parameterBag;
        $this->dataSourceManager = $dataSourceManager;
        $this->util = $util;
		$this->crudService = $crudService;
    }
    
    public function findAliquota(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName      = self::dataSourceAliquota;
        $this->parameterBagColumns = $this->parameterBagColumns;
        parent::find($request, $response);     
    }
    
    public function findOperador(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName      = self::dataSourceOperador;
        $this->parameterBagColumns = $this->parameterBagColumns;
        parent::find($request, $response);     
    }
    
    public function findTipoRece(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName      = self::dataSourceTipoRece;
        $this->parameterBagColumns = $this->parameterBagColumns;
        parent::find($request, $response);     
    }
    
    public function findImposto(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName      = self::dataSourceImposto;
        $this->parameterBagColumns = $this->parameterBagColumns;
        parent::find($request, $response);     
    }
    
    public function saveAliquota(DTO\Request\DataSet $request, DTO\Response $response) {
        $this->dataSourceName    = self::dataSourceAliquota;
        parent::save($request, $response);
    }
    
    public function saveOperador(DTO\Request\DataSet $request, DTO\Response $response) {
        $this->dataSourceName    = self::dataSourceOperador;
        parent::save($request, $response);
    }
    
    public function saveTipoRece(DTO\Request\DataSet $request, DTO\Response $response) {
        $this->dataSourceName    = self::dataSourceTipoRece;
        parent::save($request, $response);
    }
    
    public function saveImposto(DTO\Request\DataSet $request, DTO\Response $response) {
        $this->dataSourceName    = self::dataSourceImposto;
        parent::save($request, $response);
    }
}
