<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use \Zeedhi\Framework\DTO\Request\Row;
use Teknisa\MAN\Services;

class ParametrosIntegracao extends \Zeedhi\Framework\Controller\Simple {

	protected $paramVendaService;
	protected $instanceManager;

	public function __construct(Services\ParametrosIntegracao $paramIntegracaoService, \Zeedhi\Framework\DependencyInjection\InstanceManager $instanceManager,
		\Service\GetParametro $getParametroService) {
		$this->paramIntegracaoService   = $paramIntegracaoService;
		$this->instanceManager          = $instanceManager;
		$this->getParametroService      = $getParametroService;
	}

	public function saveParamIntergracao(Row $params, Response $response){
		$array          = $params->getRow();
		$parametros = $this->paramIntegracaoService->saveParametrosIntegracao($array);
	}

	public function getTiporeceFilial(Request\Filter $request, Response $response){
		$retorno  = $request->getFilterCriteria()->getConditions();
		$nrorg    = $retorno[2]['value'];
		$cdfilial = $retorno[3]['value'];
		$param    = array('CDFILIAL'=>$cdfilial, 'NRORG'=>$nrorg);
		$parametros= $this->paramIntegracaoService->getTiporeceFilial($param);
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('/getTiporeceFilial', $parametros));

	}

	public function saveIntegracaoFilial(Row $params, Response $response){
		$array          = $params->getRow();
		$parametros = $this->paramIntegracaoService->saveIntegracaoFilial($array);
	}

	public function getParametro(Row $params, Response $response){
		$array  = $params->getRow();
		$parametros = $this->getParametroService->getParametro($array);
		$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('/getParametro', $parametros));
		
	}

}