<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DB\StorageProcedure\Param;

class RelVendasRealizadasMediaPessoa extends \Teknisa\MAN\Controllers\TeknisaCrud {
    
    protected $dataSourceName = 'vnd55012_relVendasRealizadasMediaPessoa';
    protected $utilService;
    protected $vendasMediaPessoa;

    public function __construct ($crudService, $parameterBag, $entityManager, Utilities\Util $utilService, Services\RelVendasRealizadasMediaPessoaService $vendasMediaPessoa ){
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
		$this->entityManager = $entityManager;
		$this->vendasMediaPessoa = $vendasMediaPessoa;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        try{
            $conditions = $this->utilService->getParamsAsArray($request);
            if(array_key_exists('CDFILIAL', $conditions)) {
                $conditions['CDFILIAL'] = implode( '_' , $conditions['CDFILIAL']);
            }     
            $conditions['TCDCAIXA'] = 'T';
            $conditions['TCDVENDEDOR'] = 'T';
            if( array_key_exists('TCDFILIAL', $conditions)){
                $conditions['TCDFILIAL'] = 'T';
            }
            if( array_key_exists('CDVENDEDOR', $conditions)) {
                $conditions['CDVENDEDOR'] = implode($conditions['CDVENDEDOR'], '_');
                $conditions['TCDVENDEDOR'] = null;
            }          
            if ( !array_key_exists('CDVENDEDOR', $conditions)){
                $conditions['CDVENDEDOR'] = null;
            }  
            if( array_key_exists('DTENTRVENDA', $conditions) ) {
                $conditions['DTVENDAINI'] = $conditions['DTENTRVENDA'][0];
                $conditions['DTVENDAFIN'] = $conditions['DTENTRVENDA'][1];
                
                unset($conditions['DTENTRVENDA']);
            } 
            if( array_key_exists('CDFILICAIXA', $conditions) && $conditions['CDFILICAIXA']  ) {
                $conditions['CDCAIXA'] = implode($conditions['CDFILICAIXA'], '_');
                
                $conditions['TCDCAIXA'] = 'F';
                unset($conditions['CDFILICAIXA']);
            }  else {
                $conditions['CDCAIXA'] = null;
                $conditions['TCDCAIXA'] = 'T';    
            }
            if( !array_key_exists('CDCAIXA', $conditions) ) {
                $conditions['CDCAIXA'] = null;
            }
            $response->addDataSet(new DataSet("vnd55012_relVendasRealizadasMediaPessoa", 
            $this->vendasMediaPessoa->vendasRealizadas($conditions['CDFILIAL'], $conditions['CDCAIXA'], $conditions['TCDCAIXA'], $conditions['CDVENDEDOR'], $conditions['TCDVENDEDOR'], $conditions['DTVENDAINI'], $conditions['DTVENDAFIN'])));
            return $response;
                
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    
    }
}